// C Header File
// Created 8/24/2002; 12:45:18 PM

void UpdateGhostsOnMinimap(FATCONFIG *fc);
void UpdateDotOnMinimap(FATCONFIG *fc,short x,short y);
void SetGhostsToAttack(void);

#define GHOST_MOVE_AMT 3
#define AWAY_AMT 12



void GhostTurn(FATSPRITE* spr,short right,short increment) {
    spr->orientation += (right) ? increment : -increment;
    // now clamp the camera orientation to the valid range of 0 ... 575
    spr->orientation = FAT_ClampAngle(spr->orientation);
}

void GhostMove(FATCONFIG* fc,FATSPRITE* spr,short stepx,short stepy,short newxpos,short newypos) {
    short newxmod = newxpos >> 6;
    short newymod = newypos >> 6;

    //-------------------------------------------------------------------------
    // check if we are still within the map
    //-------------------------------------------------------------------------
    if (newxmod > fc->map_width-1  ||
        newymod > fc->map_height-1 ||
        newxmod < 0 || newymod < 0)
    {
       return;
    }

    if (!ValidMove(fc, newxpos, newypos)) {  // if new position is invalid ...
        // ...but old position is OK, we're against a wall to east or west
        if (ValidMove(fc, spr->xpos, newypos)) {
            // don't change angle if movement is perpendicular to the wall
            if (stepy != 0) {
                // if sign(stepx)==sign(stepy), rotate clockwise = turn right
                if ((stepx>0)==(stepy>0)) GhostTurn(spr,1,ANGLE_015/2);
                else                      GhostTurn(spr,0,ANGLE_015/2);
                // still allow movement along y = parallel to wall
                spr->ypos = newypos;
            }
        }
        // ...but (new x, old y) is OK, we're against a wall to north or south
        if (ValidMove(fc, newxpos, spr->ypos)) {
            // don't change angle if movement is perpendicular to the wall
            if (stepx != 0) {
               // if sign(stepx)==sign(stepy), rotate counterclockwise = turn left
               if ((stepx>0)==(stepy>0)) GhostTurn(spr,0,ANGLE_015/2);
               else                      GhostTurn(spr,1,ANGLE_015/2);
               // still allow movement along x = parallel to wall
               spr->xpos = newxpos;
            }
        }
        // ...otherwise we're in a corner, so do nothing
        return;
    }

    //-------------------------------------------------------------------------
    // everything okay -> let's set the new position
    //-------------------------------------------------------------------------
    spr->xpos = newxpos;
    spr->ypos = newypos;
}


//Initialize ghost spawn point
short InitGhosts(FATCONFIG *fc)
{
FATSPRITE *cursprite;
short x,y,count;

gamedata.ghosts.move = 0;
gamedata.ghosts.count = gamedata.cfg.ghost_count;


for(y=0;y<gamedata.ysize;y++)
{
	for(x=0;x<gamedata.xsize;x++)
	{
		if((fc->map_data[y*gamedata.xsize + x]==-2)) //If the location is the spawn point
		{
		gamedata.ghosts.spawnx = x;
		gamedata.ghosts.spawny = y;
goto ok;
		}

	}

}
		gamedata.ghosts.spawnx = 1;
		gamedata.ghosts.spawny = 1;
ok:


ghostspr = (FATSPRITE*)allspr;
cursprite = (FATSPRITE*)ghostspr;

for(count=0;count<gamedata.cfg.ghost_count;)
{
    //-------------------------------------------------------------------------
    // initialize sprite structure and setup its fields
    //-------------------------------------------------------------------------
    
    FAT_InitSprite(cursprite);
    cursprite->drawmode    = THE_GHOST_MODE;
    cursprite->nr_textures = 1;
    cursprite->textures    = (TEXCONFIG*) sprite_tex+2; //the ghost sprite
    cursprite->orientation = 0;
    cursprite->xpos        = (gamedata.ghosts.spawnx*64)+16;
    cursprite->ypos        = (gamedata.ghosts.spawny*64)+16;
    count++;
    if(count<(gamedata.cfg.ghost_count)) ++cursprite;
}
    
return 0;

}


void CheckGhosts(FATCONFIG *fc)
{
FATSPRITE *cursprite = (FATSPRITE*)ghostspr;
short count;
short update=0;
short dx,dy;
short angle;
short stepx;
short stepy;
short newxpos;
short newypos;
short x;
short y;
short gx,gy;
/*
short spritedir;
short inc;
short location;


// Delta direction array
// [][0] is x and [][1] is y.
const BYTE dir_array[8][2]=
{
{1,0},
{1,1},
{0,1},
{-1,1},
{-1,0},
{-1,-1},
{0,-1},
{1,-1}	
};

#define CHECKPLACES 8

GhostCheckStruct ghost_data[CHECKPLACES];
short TheBestPlace=0;
short TheBestX;
short TheBestY;

*/
gamedata.ghosts.count = gamedata.cfg.ghost_count;
for(count=0;count<gamedata.cfg.ghost_count;count++)
{
	if(int5_counter>(100+count5_start))
	{
	if(gamedata.ghosts.move<gamedata.cfg.ghost_count)
		gamedata.ghosts.move++;
		count5_start = int5_counter;
	}	
}

	
if(!gamedata.ghosts.move) return;
for(count=0;count<gamedata.ghosts.count;count++)
{
if(gamedata.ghosts.move<(count+1)) break;
if(cursprite->drawmode==SPRITEMODE_UNUSED) continue;

dx = cursprite->xpos - fc->cam_xpos;
dy = cursprite->ypos - fc->cam_ypos;
gx = cursprite->xpos;
gy = cursprite->ypos;
x = gx >> 6;
y = gy >> 6;
gamedata.ghost[count].oldx = x;
gamedata.ghost[count].oldy = y;
/*
spritedir = cursprite->orientation;

// Change to a value within 0 and 8
// This came from scale_it.c, FAT engine.
spritedir = ((spritedir+ANGLE_045/2)/ANGLE_045);
if (spritedir == 8) spritedir = 0;
*/
// Remember that East is defined as 0,
// which does make sense.
/*

for(inc=0;inc<CHECKPLACES;inc++)
{
	location = (dir_array[inc][1] * gamedata.xsize) + dir_array[inc][0];
	ghost_data[inc].orientation = inc*ANGLE_045;
	// Begin Delta X and Y as the sprite position being checked.
	ghost_data[inc].dx = gx + (FAT_Cos16384(ghost_data[inc].orientation) >> 11)*GHOST_MOVE_AMT;
	ghost_data[inc].dy = gy + (FAT_Sin16384(ghost_data[inc].orientation) >> 11)*GHOST_MOVE_AMT;
	// Then take the player into account.
	ghost_data[inc].dx -= fc->cam_xpos;
	ghost_data[inc].dy -= fc->cam_ypos;
	

	ghost_data[inc].open = !(fc->map_data[location]==WALL_TILE);
}

TheBestX = gamedata.xsize * 64;
TheBestY = gamedata.ysize * 64;


for(inc=0;inc<CHECKPLACES;inc++)
{

	if(
	((PACABS(ghost_data[inc].dx)<TheBestX)
	&&(PACABS(ghost_data[inc].dy)<TheBestY)&&ghost_data[inc].open)||
	
	((PACABS(ghost_data[inc].dx)>TheBestX)
	&&(PACABS(ghost_data[inc].dy)>TheBestY)&&gamedata.ghosts.hiding&&ghost_data[inc].open)
	)
	{

TheBestX = PACABS(ghost_data[inc].dx);
TheBestY = PACABS(ghost_data[inc].dy);
TheBestPlace = inc;
	} 
}

angle = FAT_GetArcTanYX(ghost_data[TheBestPlace].dy,ghost_data[TheBestPlace].dx);
cursprite->orientation = FAT_ClampAngle(angle-ANGLE_180);

*/


if(gamedata.ghost[count].adjust)
angle = gamedata.ghost[count].adjust;
else 
{
		// Begin Delta X and Y as the sprite position being checked.
	dx = gx;// + (FAT_Cos16384(cursprite->orientation) >> 11)*GHOST_MOVE_AMT;
	dy = gy;// + (FAT_Sin16384(cursprite->orientation) >> 11)*GHOST_MOVE_AMT;
	// Then take the player into account.
	dx -= fc->cam_xpos;
	dy -= fc->cam_ypos;
	angle = FAT_GetArcTanYX(dy,dx);
}

cursprite->orientation = FAT_ClampAngle(angle);
if(gamedata.ghosts.hiding) cursprite->orientation = FAT_ClampAngle(cursprite->orientation - ANGLE_180);

stepx   = (FAT_Cos16384(cursprite->orientation) >> 11)*GHOST_MOVE_AMT;
stepy   = (FAT_Sin16384(cursprite->orientation) >> 11)*GHOST_MOVE_AMT;
newxpos = cursprite->xpos + stepx;
newypos = cursprite->ypos + stepy;

GhostMove(fc,cursprite,stepx,stepy,newxpos,newypos);
if(gx==cursprite->xpos && gy==cursprite->ypos)
{
if(gamedata.ghost[count].adjust)
	gamedata.ghost[count].adjust = 0;
else
	gamedata.ghost[count].adjust = cursprite->orientation + ANGLE_090;

}

	if((x!=cursprite->xpos>>6)||(y!=cursprite->ypos>>6))	
	update=1;

++cursprite;
}
if(update) UpdateGhostsOnMinimap(fc);

if(gamedata.ghosts.hiding) gamedata.ghosts.hiding--;
if(!gamedata.ghosts.hiding) SetGhostsToAttack();

}


void CheckGhostCollision(FATCONFIG *fc)
{
short count;
short camx,camy;


FATSPRITE *cursprite = (FATSPRITE*)ghostspr;


camx = (fc->cam_xpos>>6);
camy = (fc->cam_ypos>>6);
for(count=0;count<gamedata.ghosts.count;)
{
#define DEATH_AWAY 12
if(
((camx==((cursprite->xpos-DEATH_AWAY)>>6))&&(camy==((cursprite->ypos-DEATH_AWAY)>>6))) ||
((camx==((cursprite->xpos)>>6))&&(camy==((cursprite->ypos-DEATH_AWAY)>>6))) ||
((camx==((cursprite->xpos+DEATH_AWAY)>>6))&&(camy==((cursprite->ypos-DEATH_AWAY)>>6))) ||
((camx==((cursprite->xpos-DEATH_AWAY)>>6))&&(camy==((cursprite->ypos)>>6))) ||
((camx==((cursprite->xpos)>>6))&&(camy==((cursprite->ypos)>>6))) ||
((camx==((cursprite->xpos+DEATH_AWAY)>>6))&&(camy==((cursprite->ypos)>>6))) ||
((camx==((cursprite->xpos-DEATH_AWAY)>>6))&&(camy==((cursprite->ypos+DEATH_AWAY)>>6))) ||
((camx==((cursprite->xpos)>>6))&&(camy==((cursprite->ypos+DEATH_AWAY)>>6))) ||
((camx==((cursprite->xpos+DEATH_AWAY)>>6))&&(camy==((cursprite->ypos+DEATH_AWAY)>>6)))
) 
{
	if(!gamedata.ghosts.hiding) KillPlayer(fc);
	else
	{
		UpdateDotOnMinimap(fc,gamedata.ghost[count].oldx,gamedata.ghost[count].oldy);
		cursprite->drawmode = SPRITEMODE_UNUSED;
		UpdateGhostsOnMinimap(fc);
	}
	 
	break;
}
count++;
++cursprite;
}

}



void SetGhostsToRunAway(void)
{
FATSPRITE *cursprite = (FATSPRITE*)ghostspr;
short count;
gamedata.ghosts.hiding = 120;

for(count=0;count<gamedata.cfg.ghost_count;)
{
    cursprite->textures    = (TEXCONFIG*) sprite_tex+3; //the ghost running away sprite
    count++;
    if(count<(gamedata.cfg.ghost_count)) ++cursprite;
}
}

void SetGhostsToAttack(void)
{
FATSPRITE *cursprite = (FATSPRITE*)ghostspr;
short count;

for(count=0;count<gamedata.cfg.ghost_count;)
{
    cursprite->textures    = (TEXCONFIG*) sprite_tex+2; //the ghost sprite
    count++;
    if(count<(gamedata.cfg.ghost_count)) ++cursprite;
}
}
